routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
//Route group: a groupon belüli összes routra igaz lesz.
//Groupon belül minden Controllert a Controllers/Admin-namespace alatt fog keresni.


use App\Http\Controllers\Admin\NotesController;

Route::middleware('customer_auth')->group(function () {
  Route::get('/ugyfelek', 'CustomersController@index')->name('customers.index');
  Route::delete('/kilepes', 'CustomerAuthController@destroy')->name('login.destroy');

  Route::get('jegyzeteim', 'NotesController@ownNotes')->name('notes.ownNotes');

  Route::delete('jegyzeteim/torles/{noteId}', 'NotesController@destroy')->name('notes.destroy');

  Route::get('/jegyzetek/uj-jegyzet', 'NotesController@create')->name('notes.create');
  Route::post('/jegyzetek/uj-jegyzet', 'NotesController@store')->name('notes.store');

  Route::get('/jegyzetek/{noteId}/modositas', 'NotesController@edit')->name('notes.edit');
  Route::put('/jegyzetek/{noteId}/modositas', 'NotesController@update')->name('notes.update');

  //a jegyzetek/ routok közül legalulra kerül, mert különben a jegyzetek/uj-jegyzet esetén az "uj-jegyzet" részt {customerId}nak gondolva ebbe futna bele.

  Route::post('/jegyzetek/{noteId}/hozzaszolas', 'CommentsController@store')->name('comments.store');
  Route::get('/stat/{type?}','StatController@index')->name('stat');
});

Route::get('/jegyzetek/{customerId?}', 'NotesController@index')->name('notes.index');
Route::get('/jegyzet/{noteId}', 'NotesController@show')->name('notes.show');

/*
Route::get('/', 'PagesController@index')->name('index');
*/
Route::get('/', function (){
    return view('frontend.auth.create');
})->name('index');

//create, store
Route::get('/regisztracio', 'CustomersController@create')->name('customers.create');
Route::post('/regisztracio', 'CustomersController@store')->name('customers.store');


//edit, update
Route::get('/ugyfel/{customerId}/modositas', 'CustomersController@edit')->name('customers.edit');
Route::put('/ugyfel/{customerId}/modositas', 'CustomersController@update')->name('customers.update');

Route::delete('ugyfel/{customerId}/torles', 'CustomersController@destroy')->name('customers.destroy');

Route::get('/ugyfel/{id}', 'CustomersController@show')->name('customers.show');


Route::get('/belepes', 'CustomerAuthController@create')->name('login.create');

Route::post('/belepes', 'CustomerAuthController@store')->name('login.store');


//  Route::post('/login', 'Auth\LoginController@login')->name('login.store');
//Route::post('/belepes', 'CustomerAuthController@store')->name('login.store');

Route::get('/customer', 'CustomersController@newCustomer')->name('customers.newCustomer');

Route::namespace('Admin')->prefix('admin')->name('admin.')->group(function () { //
  //innentől pedig a Controllers/Admin/Auth-ban
  Route::namespace('Auth')->group(function () {
    Route::get('/belepes', 'LoginController@showLoginForm')->name('login.create');
    Route::get('/kilepes', 'LoginController@logout')->name('logout');
    Route::post('/belepes', 'LoginController@login')->name('login.store');
  });

  Route::middleware('admin_auth')->group(function () {
    Route::get('/', 'DashboardController@index')->name('dashboard');
    Route::prefix('customer')->name('customer.')->group(function () {
        //Route::get('/ajaxData', 'CustomerController@ajaxData')->name('ajaxData');
        Route::resource('','CustomerController')->parameters([''=>'id']);
    });
    Route::resource('note','NotesController');
      //Route::resource(customer','CustomerController')->parameters([''=>'id']);
  });
});

app/Models/Note.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Carbon\Carbon;

/**
 * App\Models\Note
 *
 * @property int $id
 * @property int|null $customer_id
 * @property string|null $content
 * @property \Illuminate\Support\Carbon|null $created_at
 * @property \Illuminate\Support\Carbon|null $updated_at
 * @property string|null $public_at
 * @property string|null $title
 * @property-read \Illuminate\Database\Eloquent\Collection|\App\Models\Comment[] $comments
 * @property-read int|null $comments_count
 * @property-read \App\Models\Customer|null $customer
 * @property-read \Illuminate\Database\Eloquent\Collection|\App\Models\Tag[] $tags
 * @property-read int|null $tags_count
 * @method static \Illuminate\Database\Eloquent\Builder|Note newModelQuery()
 * @method static \Illuminate\Database\Eloquent\Builder|Note newQuery()
 * @method static \Illuminate\Database\Eloquent\Builder|Note onFrontend()
 * @method static \Illuminate\Database\Eloquent\Builder|Note query()
 * @method static \Illuminate\Database\Eloquent\Builder|Note whereContent($value)
 * @method static \Illuminate\Database\Eloquent\Builder|Note whereCreatedAt($value)
 * @method static \Illuminate\Database\Eloquent\Builder|Note whereCustomerId($value)
 * @method static \Illuminate\Database\Eloquent\Builder|Note whereId($value)
 * @method static \Illuminate\Database\Eloquent\Builder|Note wherePublicAt($value)
 * @method static \Illuminate\Database\Eloquent\Builder|Note whereTitle($value)
 * @method static \Illuminate\Database\Eloquent\Builder|Note whereUpdatedAt($value)
 * @mixin \Eloquent
 */
class Note extends Model
{

  public function getCustomerName()
  {
      $customer = Customer::find($this->customer_id);

      return $customer->name;
  }

  public function hasTag($tagId)
  {
    return $this->tags()->find($tagId);
  }

  public function customer()
  { //1-többhöz kapcsolat, 'customer_id'  idegen kulcsal.
  //  return $this->belongsTo(Customer::class/*, 'customer_id'*/);/*Default elnevezésnél nem kell megadni*/
    return $this->belongsTo(Customer::class);
  }

  public function tags()
  {
    return $this->belongsToMany(Tag::class)->withTimestamps();
  }

  public function comments()
  {
    return $this->hasMany(Comment::Class);
  }

  public function setAttributes($data)
  {
    $this->content = isset($data['content']) ? $data['content'] : '';
    $this->public_at =  isset($data['public_at']) ? $data['public_at'] : null;
    $this->title =  isset($data['title']) ? $data['title'] : null;
  }

  public function scopeOnFrontend($query)
  {
    $query->whereNotNull('public_at')->whereDate('public_at', '<=', now());
  }


}

app/Http/Controllers/Admin/NotesController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Customer;
use App\Models\Note;
use App\Models\Tag;
use Illuminate\Http\Request;
use Yajra\DataTables\DataTables;

class NotesController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        //dd(Note::with('customer')->get()->toArray());


        if ($request->ajax()) {
            $query=Note::with('customer','tags')->select();
            return Datatables::of($query)->make(true);
        }
        //dd(Note::with('customer','tags')->get()->toArray());

        return view('admin.notes.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $item = Note::with('tags')->findOrFail($id);
        return view('admin.notes.editForm')
            ->with([
                'item'=> $item,
                'tags'=>Tag::all(),
            ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {

        $this->validate($request, [
            'title' => 'required|string|min:3',
            'content' => 'required|string|min:3',
        ]);

        $item = Note::find($id);
        $item->setAttributes($request->all());
        $item->save();

        $item->tags()->sync($request->input('tags'));
        return response()->json(['succes' => true, 'data' => ['item' => $item->toArray()]]);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $item = Note::findOrFail($id);
        $item->delete();
        return response()->json(['succes' => true]);
    }
}

app/Http/Controllers/NotesController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Note;
use App\Models\Customer;
use Carbon\Carbon;
use App\Models\Tag;

class NotesController extends Controller
{

  public function __construct()
  {
    $this->middleware('own_note')->only(['edit', 'update', 'destroy']);
  }

  public function show($noteId)
  {
    $note = Note::findOrFail($noteId);

    return view('frontend.notes.show')->with('note', $note);
  }

                        //ha nincs megadva, akkor null
  public function index($customerId = null)
  {
    if($customerId) {
        $customer = Customer::find($customerId);
        $notes = $customer->notes; //$customer->notes()->get(); rövid formája
    
        $now = Carbon::now();
        //csak mai jegyzetek.       //whereDate: elég ha a dátum egyezik, az időpont részt figyelmen kívül hagyja.
        $notes = $customer->notes()->whereDate('created_at', '=', $now)->orderBy('created_at', 'desc')->get();
    }

    $notes = Note::onFrontend()->get();

    return view('frontend.notes.index')->with('notes', $notes);
  }

  public function create()
  {                 //ha nincs megadva másik paraméter az orderBy() nál akkor növekvőbe rendez.
    $tags = Tag::orderBy('name')->get();

    return view('frontend.notes.create')->with('tags', $tags);
  }


  public function store(Request $request)
  {
      $note = new Note;
      $note->customer_id = auth()->guard('customer')->id();// ugyanaz, mint  $note->customer()->associate(auth()->guard('customer')->id())
      $note->setAttributes($request->all());
      $note->save();
      //fontos, hogy a save az attach előtt szerepeljen, mert csak a save() után, az adatbázisba kerüléskor kap a $note id-t.
      $note->tags()->attach($request->input('tags'));

      return redirect()->route('notes.ownNotes');
  }

  public function edit($noteId)
  {
    $note = authCustomer()->notes()->findOrFail($noteId);
    $tags = Tag::orderBy('name')->get();

    return view('frontend.notes.edit')
    ->with('note', $note)
    ->with('tags', $tags);
  }

  public function update(Request $request, $noteId)
  {
      $note = Note::find($noteId);
      $note->setAttributes($request->all());
      $note->save();

      $note->tags()->sync($request->input('tags'));

      return redirect()->route('notes.ownNotes');
  }

  public function ownNotes()
  {
    $notes = authCustomer()->notes;

    return view('frontend.notes.own-notes')
      ->with('notes', $notes);
  }

  public function destroy($customerId)
  {
      $customer = Customer::findOrFail($customerId);
      $customer->delete();

      return response()->json(['message' => 'Az ügyfél törölve']);
  }

}

resources/views/admin/notes/editForm.blade.php
<div class="card card-primary">
    <div class="card-header">
        <h3 class="card-title">Jegyzet Adatok</h3>
    </div>
    <!-- form start -->
    <form class="editorForm" action="{{route('admin.note.update',$item->id)}}" method="POST">
        @csrf
        <input type="hidden" name="_method" value="PUT">
        <div class="card-body">
            <div class="form-group">
                <label for="inputCim">Cím</label>
                <input type="text" class="form-control" id="inputCim" placeholder="Írjon Címet" name="title"
                       value="{{$item->title}}">
            </div>

            <div class="form-group">
                <label>Jegyzet</label>
                <textarea class="form-control" name="content">{{$item->content}}</textarea>
            </div>
            <div class="form-group" data-select2-id="105">
                <label>Tagek</label>
                <select class="select2 select2-hidden-accessible select2-blue select2-container--below"
                        multiple="multiple"
                        data-placeholder="Kattints a kiválasztáshoz"
                        style="width: 100%;"  tabindex="-1" aria-hidden="false"
                        name="tags[]"
                >
                    @foreach($tags as $tag)
                        <option value="{{$tag->id}}">{{$tag->name}}</option>
                    @endforeach
                </select>
{{--

                <span class="select2
                    select2-container
                    select2-container--default
                    select2-container--below"
                      dir="ltr" data-select2-id="8" style="width: 100%;">
                    <span class="selection"><span class="select2-selection select2-selection--multiple" role="combobox" aria-haspopup="true" aria-expanded="false" tabindex="-1" aria-disabled="false"><ul class="select2-selection__rendered"><li class="select2-search select2-search--inline"><input class="select2-search__field" type="search" tabindex="0" autocomplete="off" autocorrect="off" autocapitalize="none" spellcheck="false" role="searchbox" aria-autocomplete="list" placeholder="Select a State" style="width: 769.5px;"></li></ul></span></span><span class="dropdown-wrapper" aria-hidden="true">

                    </span></span>
--}}


            </div>
        </div>


        <!-- /.card-body -->

        <div class="card-footer">
            <button type="submit" class="btn btn-primary btnSubmit">Submit</button>
        </div>
    </form>
    <script>

        window.callbackAction = function (data) {
            console.log('callbackAction');
            console.log(data);
        }
        window.errorCallbackAction = function (data) {
            console.log('errorCallbackAction');
            console.log(data);
        }

        window.ajaxErrorFieldHandler = function (errors, container) {
            let toastBodyHtml = '';
            $.each(errors, function (index, value) {
                toastBodyHtml += '<div>' + value + '<div>';
            });
            Toast.fire({
                icon: 'error',
                html: toastBodyHtml
            });
        }

        $('.editorForm .btnSubmit').click(function (event) {
            var form = $('.editorForm .btnSubmit').closest('form');
            var ajaxDataForm = form.serializeArray();
            //ajaxDataForm.push({name:'callback',value:'callbackAction'});
            //ajaxDataForm.push({name:'errorCallback',value:'errorCallbackAction'});
            $.ajax({
                url: form.attr('action'),
                type: 'PUT',
                headers: {
                    'X-CSRF-TOKEN': $('input[name="_token"]').val()
                },
                data: ajaxDataForm,
                success: function (data) {
                    $(modalId).modal('hide');
                    dTable.ajax.reload(null, false);
                    Toast.fire({
                        icon: 'success',
                        html: 'Sikeres adatmodositas'
                    });
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    if (xhr.responseJSON.errors) {
                        ajaxErrorFieldHandler(xhr.responseJSON.errors);
                    }
                },
            });
            event.preventDefault();
        });

        $('.select2').val({{$item->tags->pluck('id')->toJson()}}).select2()

    </script>
</div>

resources/views/admin/notes/index.blade.php
@extends('admin.layout.admin-layout')
@section('content')

    <div class="content-wrapper">
        <!-- Content Header (Page header) -->
        <section class="content-header">

                    <!-- Button trigger modal -->
                    <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#ModalForm">
                        Launch demo modal
                    </button>
        {{--
        --}}

        <!-- Modal -->
            <div class="modal fade" id="ModalForm" tabindex="-1" role="dialog" aria-labelledby="modalTitle" aria-hidden="true">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header" style="display: none">
                            <h5 class="modal-title" >Modal title</h5>
                            <button type="button" class="close btnClose" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body">
                            ...
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-secondary btnCancel" data-dismiss="modal">Close</button>
                            <button type="button" class="btn btn-primary btnSave">Save changes</button>
                        </div>
                    </div>
                </div>
            </div>

            <table class="table" id="dataTableBuilder">
                <thead>
                <tr>
                    <th title="Id"> Id</th>
                    <th title="Name">Name</th>
                    <th title="Email"> Email</th>
                    <th title="Created At">Created At</th>
                    <th title="Updated At"> Updated At</th>
                    <th title="action"> </th>
                    <th title="action"> </th>
                </tr>
                </thead>
            </table>
        </section>
        <!-- /.content -->
    </div>
    <!-- /.content-wrapper -->
    <script>
        let dTable;
        $(document).ready(function() {

            dTable=$("#dataTableBuilder").DataTable({
                language: {
                    url: '//cdn.datatables.net/plug-ins/1.10.24/i18n/Hungarian.json'
                },
                "paging": true,
                //"pagingType": "full_numbers",
                "lengthChange": false,
                "searching": true,
                "ordering": true,
                "info": true,
                "autoWidth": false,
                "responsive": true,
                "serverSide": true,
                "processing": true,
                "ajax": "{{route('admin.note.index')}}",
                rowId: 'id',
                "columns": [
                    {
                        "data": "id",
                        "name": "id",
                        "title": "Id",
                        "orderable": true,
                        "searchable": true
                    },
                    {
                        "data": "title",
                        "name": "title",
                        "title": "Title",
                        "orderable": true,
                        "searchable": true
                    },
                    {
                        "data": "content",
                        "render":function (data,type,row){

                          return data.length>30? data.substr(0,27)+'..':data;
                        },
                        "name": "content",
                        "title": "Jegyzet",
                        "orderable": true,
                        "searchable": true
                    },

                    {
                        "data": "customer.name",
                        "name": "customer.name",
                        "title": "Customer",
                        "orderable": true,
                        "searchable": true
                    },
                    {
                        "data": "created_at",
                        "name": "created_at",
                        "title": "Created At",
                        "orderable": true,
                        "searchable": true
                    }, {
                        "data": "updated_at",
                        "name": "updated_at",
                        "title": "Updated At",
                        "orderable": true,
                        "searchable": true
                    },{
                        data: null,
                        "title": "Action",
                        className: "dt-center ",
                        defaultContent: '<a class="btn btn-xs btn-primary dt-editorBtn editor-edit"><i class="fas fa-pencil-alt"></i> Edit</a>' +
                            '<a class="btn btn-xs btn-danger dt-editorBtn editor-delete"><i class="fas fa-trash"></i> Törlés</a>' +
                            '',
                        orderable: false,
                        "searchable": false
                    },
                ]
            });

        });


        $('#dataTableBuilder').on('click', 'a.editor-edit', function (e) {
            e.preventDefault();
            let ajaxUrl="{{route('admin.note.edit',':id')}}";
            ajaxUrl=ajaxUrl.replace(':id',dTable.row( $(this).closest('tr') ).id());
            modalForm({bodyAjaxUrl:ajaxUrl});
        } );

        $('#dataTableBuilder').on('click', 'a.editor-delete', function (e) {
            e.preventDefault();
            let ajaxUrl="{{route('admin.note.destroy',':id')}}";
            ajaxUrl=ajaxUrl.replace(':id',dTable.row( $(this).closest('tr') ).id());
            $.ajax({
                url: ajaxUrl,
                type: 'DELETE',
                headers: {
                    'X-CSRF-TOKEN': '{{csrf_token()}}'
                },
                success: function (data) {
                    dTable.ajax.reload(null,false);
                    Toast.fire({
                        icon: 'info',
                        html: 'Sikeres törlés'
                    });
                },
                error:function (xhr, ajaxOptions, thrownError){
                    if(xhr.responseJSON.errors){
                        ajaxErrorFieldHandler(xhr.responseJSON.errors);
                    };
                },
            });

        });
    </script>
@endsection